diff --git a/lib/libsdp/sdp.h b/lib/libsdp/sdp.h
index 1778a6d60b..c9f1127314 100644
--- a/lib/libsdp/sdp.h
+++ b/lib/libsdp/sdp.h
@@ -1,35 +1,3 @@
-/* $NetBSD: sdp.h,v 1.2 2006/08/17 20:13:31 plunky Exp $ */
-
-/*-
- * Copyright (c) 2006 Itronix Inc.
- * All rights reserved.
- *
- * Written by Iain Hibbert for Itronix Inc.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
- *    documentation and/or other materials provided with the distribution.
- * 3. The name of Itronix Inc. may not be used to endorse
- *    or promote products derived from this software without specific
- *    prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY ITRONIX INC. ``AS IS'' AND
- * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
- * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
- * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL ITRONIX INC. BE LIABLE FOR ANY
- * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
- * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
- * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
- * ON ANY THEORY OF LIABILITY, WHETHER IN
- * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
- * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
- * POSSIBILITY OF SUCH DAMAGE.
- */
 /*
  * sdp.h
  *
@@ -57,17 +25,13 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- * $Id: sdp.h,v 1.2 2006/08/17 20:13:31 plunky Exp $
- * $FreeBSD: src/lib/libsdp/sdp.h,v 1.5 2005/05/27 19:11:33 emax Exp $
+ * $Id: sdp.h,v 1.3 2003/09/05 00:33:59 max Exp $
+ * $FreeBSD: head/lib/libsdp/sdp.h 226426 2011-10-16 08:45:16Z ed $
  */
 
 #ifndef _SDP_H_
 #define _SDP_H_
 
-#include <stdint.h>
-#include <string.h>
-#include <netbt/bluetooth.h>
-
 __BEGIN_DECLS
 
 /*
@@ -104,7 +68,7 @@ __BEGIN_DECLS
 /* Boolean */
 #define SDP_DATA_BOOL					0x28
 
-/*
+/* 
  * Data element sequence.
  * A data element whose data field is a sequence of data elements
  */
@@ -114,10 +78,10 @@ __BEGIN_DECLS
 
 /*
  * Data element alternative.
- * A data element whose data field is a sequence of data elements from
+ * A data element whose data field is a sequence of data elements from 
  * which one data element is to be selected.
  */
-#define SDP_DATA_ALT8					0x3D
+#define SDP_DATA_ALT8					0x3D 
 #define SDP_DATA_ALT16					0x3E
 #define SDP_DATA_ALT32					0x3F
 
@@ -127,7 +91,7 @@ __BEGIN_DECLS
 #define SDP_DATA_URL32					0x47
 
 /*
- * Protocols UUID (short) http://www.bluetoothsig.org/assigned-numbers/sdp.htm
+ * Protocols UUID (short) https://www.bluetooth.org/assigned-numbers/service_discovery.php
  * BASE UUID 00000000-0000-1000-8000-00805F9B34FB
  */
 
@@ -155,7 +119,7 @@ __BEGIN_DECLS
 #define SDP_UUID_PROTOCOL_L2CAP				0x0100
 
 /*
- * Service class IDs http://www.bluetoothsig.org/assigned-numbers/sdp.htm
+ * Service class IDs https://www.bluetooth.org/assigned-numbers/service_discovery.php
  */
 
 #define SDP_SERVICE_CLASS_SERVICE_DISCOVERY_SERVER	0x1000
@@ -206,6 +170,9 @@ __BEGIN_DECLS
 #define SDP_SERVICE_CLASS_UDI_TA			0x112B
 #define SDP_SERVICE_CLASS_AUDIO_VIDEO			0x112C
 #define SDP_SERVICE_CLASS_SIM_ACCESS			0x112D
+#define SDP_SERVICE_CLASS_PHONEBOOK_ACCESS_PCE		0x112E
+#define SDP_SERVICE_CLASS_PHONEBOOK_ACCESS_PSE		0x112F
+#define SDP_SERVICE_CLASS_PHONEBOOK_ACCESS		0x1130
 #define SDP_SERVICE_CLASS_PNP_INFORMATION		0x1200
 #define SDP_SERVICE_CLASS_GENERIC_NETWORKING		0x1201
 #define SDP_SERVICE_CLASS_GENERIC_FILE_TRANSFER		0x1202
@@ -216,10 +183,13 @@ __BEGIN_DECLS
 #define SDP_SERVICE_CLASS_ESDP_UPNP_IP_PAN		0x1300
 #define SDP_SERVICE_CLASS_ESDP_UPNP_IP_LAP		0x1301
 #define SDP_SERVICE_CLASS_ESDP_UPNP_L2CAP		0x1302
+#define SDP_SERVICE_CLASS_VIDEO_SOURCE			0x1303
+#define SDP_SERVICE_CLASS_VIDEO_SINK			0x1304
+#define SDP_SERVICE_CLASS_VIDEO_DISTRIBUTION		0x1305
 
 /*
  * Universal attribute definitions (page 366) and
- * http://www.bluetoothsig.org/assigned-numbers/sdp.htm
+ * https://www.bluetooth.org/assigned-numbers/service_discovery.php
  */
 
 #define SDP_ATTR_RANGE(lo, hi) \
@@ -266,10 +236,11 @@ __BEGIN_DECLS
 #define SDP_ATTR_SUPPORTED_FEATURES			0x0311
 #define SDP_ATTR_SUPPORTED_FUNCTIONS			0x0312
 #define SDP_ATTR_TOTAL_IMAGING_DATA_CAPACITY		0x0313
+#define SDP_ATTR_SUPPORTED_REPOSITORIES			0x0314
 
 /*
- * The offset must be added to the attribute ID base (contained in the
- * LANGUAGE_BASE_ATTRIBUTE_ID_LIST attribute) in order to compute the
+ * The offset must be added to the attribute ID base (contained in the 
+ * LANGUAGE_BASE_ATTRIBUTE_ID_LIST attribute) in order to compute the 
  * attribute ID for these attributes.
  */
 
@@ -340,114 +311,215 @@ typedef struct sdp_attr *	sdp_attr_p;
  *****************************************************************************/
 
 /* Inline versions of get/put byte/short/long. Pointer is advanced */
-#define SDP_GET8(b, cp)		do {			\
-	(b) = *(const uint8_t *)(cp);			\
-	(cp) += sizeof(uint8_t);			\
-} while (/* CONSTCOND */0)
-
-#define SDP_GET16(s, cp)	do {			\
-	(s) = be16dec(cp);				\
-	(cp) += sizeof(uint16_t);			\
-} while (/* CONSTCOND */0)
-
-#define SDP_GET32(l, cp)	do {			\
-	(l) = be32dec(cp);				\
-	(cp) += sizeof(uint32_t);			\
-} while (/* CONSTCOND */0)
-
-#define SDP_GET64(l, cp)	do {			\
-	(l) = be64dec(cp);				\
-	(cp) += sizeof(uint64_t);			\
-} while (/* CONSTCOND */0)
+#define SDP_GET8(b, cp) { \
+	const uint8_t *t_cp = (const uint8_t *)(cp); \
+	(b) = *t_cp; \
+	(cp) ++; \
+}
+
+#define SDP_GET16(s, cp) { \
+	const uint8_t *t_cp = (const uint8_t *)(cp); \
+	(s) = ((uint16_t)t_cp[0] << 8) \
+	    | ((uint16_t)t_cp[1]) \
+	    ; \
+	(cp) += 2; \
+}
+
+#define SDP_GET32(l, cp) { \
+	const uint8_t *t_cp = (const uint8_t *)(cp); \
+	(l) = ((uint32_t)t_cp[0] << 24) \
+	    | ((uint32_t)t_cp[1] << 16) \
+	    | ((uint32_t)t_cp[2] << 8) \
+	    | ((uint32_t)t_cp[3]) \
+	    ; \
+	(cp) += 4; \
+}
+
+#define SDP_GET64(l, cp) { \
+	register uint8_t *t_cp = (uint8_t *)(cp); \
+	(l) = ((uint64_t)t_cp[0] << 56) \
+	    | ((uint64_t)t_cp[1] << 48) \
+	    | ((uint64_t)t_cp[2] << 40) \
+	    | ((uint64_t)t_cp[3] << 32) \
+	    | ((uint64_t)t_cp[4] << 24) \
+	    | ((uint64_t)t_cp[5] << 16) \
+	    | ((uint64_t)t_cp[6] << 8) \
+	    | ((uint64_t)t_cp[7]) \
+	    ; \
+	(cp) += 8; \
+}
 
 #if BYTE_ORDER == LITTLE_ENDIAN
-#define SDP_GET128(l, cp)	do {			\
-	const uint8_t *t_cp = (const uint8_t *)(cp);	\
-	(l)->b[15] = *t_cp++;				\
-	(l)->b[14] = *t_cp++;				\
-	(l)->b[13] = *t_cp++;				\
-	(l)->b[12] = *t_cp++;				\
-	(l)->b[11] = *t_cp++;				\
-	(l)->b[10] = *t_cp++;				\
-	(l)->b[9]  = *t_cp++;				\
-	(l)->b[8]  = *t_cp++;				\
-	(l)->b[7]  = *t_cp++;				\
-	(l)->b[6]  = *t_cp++;				\
-	(l)->b[5]  = *t_cp++;				\
-	(l)->b[4]  = *t_cp++;				\
-	(l)->b[3]  = *t_cp++;				\
-	(l)->b[2]  = *t_cp++;				\
-	(l)->b[1]  = *t_cp++;				\
-	(l)->b[0]  = *t_cp++;				\
-	(cp) += 16;					\
-} while (/* CONSTCOND */0)
-
-#define SDP_GET_UUID128(l, cp)	do {			\
-	memcpy(&((l)->b), (cp), 16);			\
-	(cp) += 16;					\
-} while (/* CONSTCOND */0)
+#define SDP_GET128(l, cp) { \
+	register uint8_t *t_cp = (uint8_t *)(cp); \
+	(l)->b[15] = *t_cp++; \
+	(l)->b[14] = *t_cp++; \
+	(l)->b[13] = *t_cp++; \
+	(l)->b[12] = *t_cp++; \
+	(l)->b[11] = *t_cp++; \
+	(l)->b[10] = *t_cp++; \
+	(l)->b[9]  = *t_cp++; \
+	(l)->b[8]  = *t_cp++; \
+	(l)->b[7]  = *t_cp++; \
+	(l)->b[6]  = *t_cp++; \
+	(l)->b[5]  = *t_cp++; \
+	(l)->b[4]  = *t_cp++; \
+	(l)->b[3]  = *t_cp++; \
+	(l)->b[2]  = *t_cp++; \
+	(l)->b[1]  = *t_cp++; \
+	(l)->b[0]  = *t_cp++; \
+	(cp) += 16; \
+}
+
+#define SDP_GET_UUID128(l, cp) { \
+	register uint8_t *t_cp = (uint8_t *)(cp); \
+	(l)->b[0]  = *t_cp++; \
+	(l)->b[1]  = *t_cp++; \
+	(l)->b[2]  = *t_cp++; \
+	(l)->b[3]  = *t_cp++; \
+	(l)->b[4]  = *t_cp++; \
+	(l)->b[5]  = *t_cp++; \
+	(l)->b[6]  = *t_cp++; \
+	(l)->b[7]  = *t_cp++; \
+	(l)->b[8]  = *t_cp++; \
+	(l)->b[9]  = *t_cp++; \
+	(l)->b[10] = *t_cp++; \
+	(l)->b[11] = *t_cp++; \
+	(l)->b[12] = *t_cp++; \
+	(l)->b[13] = *t_cp++; \
+	(l)->b[14] = *t_cp++; \
+	(l)->b[15] = *t_cp++; \
+	(cp) += 16; \
+}
 #elif BYTE_ORDER == BIG_ENDIAN
-#define SDP_GET128(l, cp)	do {			\
-	memcpy(&((l)->b), (cp), 16);			\
-	(cp) += 16;					\
-} while (/* CONSTCOND */0)
+#define SDP_GET128(l, cp) { \
+	register uint8_t *t_cp = (uint8_t *)(cp); \
+	(l)->b[0]  = *t_cp++; \
+	(l)->b[1]  = *t_cp++; \
+	(l)->b[2]  = *t_cp++; \
+	(l)->b[3]  = *t_cp++; \
+	(l)->b[4]  = *t_cp++; \
+	(l)->b[5]  = *t_cp++; \
+	(l)->b[6]  = *t_cp++; \
+	(l)->b[7]  = *t_cp++; \
+	(l)->b[8]  = *t_cp++; \
+	(l)->b[9]  = *t_cp++; \
+	(l)->b[10] = *t_cp++; \
+	(l)->b[11] = *t_cp++; \
+	(l)->b[12] = *t_cp++; \
+	(l)->b[13] = *t_cp++; \
+	(l)->b[14] = *t_cp++; \
+	(l)->b[15] = *t_cp++; \
+	(cp) += 16; \
+}
 
 #define	SDP_GET_UUID128(l, cp)	SDP_GET128(l, cp)
 #else
 #error	"Unsupported BYTE_ORDER"
 #endif /* BYTE_ORDER */
 
-#define SDP_PUT8(b, cp)		do {			\
-	*(uint8_t *)(cp) = (b);				\
-	(cp) += sizeof(uint8_t);			\
-} while (/* CONSTCOND */0)
-
-#define SDP_PUT16(s, cp)	do {			\
-	be16enc((cp), (s));				\
-	(cp) += sizeof(uint16_t);			\
-} while (/* CONSTCOND */0)
-
-#define SDP_PUT32(s, cp)	do {			\
-	be32enc((cp), (s));				\
-	(cp) += sizeof(uint32_t);			\
-} while (/* CONSTCOND */0)
-
-#define SDP_PUT64(s, cp)	do {			\
-	be64enc((cp), (s));				\
-	(cp) += sizeof(uint64_t);			\
-} while (/* CONSTCOND */0)
+#define SDP_PUT8(b, cp) { \
+	register uint8_t t_b = (uint8_t)(b); \
+	register uint8_t *t_cp = (uint8_t *)(cp); \
+	*t_cp = t_b; \
+	(cp) ++; \
+}
+
+#define SDP_PUT16(s, cp) { \
+	register uint16_t t_s = (uint16_t)(s); \
+	register uint8_t *t_cp = (uint8_t *)(cp); \
+	*t_cp++ = t_s >> 8; \
+	*t_cp   = t_s; \
+	(cp) += 2; \
+}
+
+#define SDP_PUT32(l, cp) { \
+	register uint32_t t_l = (uint32_t)(l); \
+	register uint8_t *t_cp = (uint8_t *)(cp); \
+	*t_cp++ = t_l >> 24; \
+	*t_cp++ = t_l >> 16; \
+	*t_cp++ = t_l >> 8; \
+	*t_cp   = t_l; \
+	(cp) += 4; \
+}
+
+#define SDP_PUT64(l, cp) { \
+	register uint64_t t_l = (uint64_t)(l); \
+	register uint8_t *t_cp = (uint8_t *)(cp); \
+	*t_cp++ = t_l >> 56; \
+	*t_cp++ = t_l >> 48; \
+	*t_cp++ = t_l >> 40; \
+	*t_cp++ = t_l >> 32; \
+	*t_cp++ = t_l >> 24; \
+	*t_cp++ = t_l >> 16; \
+	*t_cp++ = t_l >> 8; \
+	*t_cp   = t_l; \
+	(cp) += 8; \
+}
 
 #if BYTE_ORDER == LITTLE_ENDIAN
-#define SDP_PUT128(l, cp)	do {			\
-	const uint8_t *t_cp = (const uint8_t *)(cp);	\
-	*t_cp++ = (l)->b[15];				\
-	*t_cp++ = (l)->b[14];				\
-	*t_cp++ = (l)->b[13];				\
-	*t_cp++ = (l)->b[12];				\
-	*t_cp++ = (l)->b[11];				\
-	*t_cp++ = (l)->b[10];				\
-	*t_cp++ = (l)->b[9];				\
-	*t_cp++ = (l)->b[8];				\
-	*t_cp++ = (l)->b[7];				\
-	*t_cp++ = (l)->b[6];				\
-	*t_cp++ = (l)->b[5];				\
-	*t_cp++ = (l)->b[4];				\
-	*t_cp++ = (l)->b[3];				\
-	*t_cp++ = (l)->b[2];				\
-	*t_cp++ = (l)->b[1];				\
-	*t_cp   = (l)->b[0];				\
-	(cp) += 16;					\
-} while (/* CONSTCOND */0)
-
-#define SDP_PUT_UUID128(l, cp)	do {			\
-	memcpy((cp), &((l)->b), 16);			\
-	(cp) += 16;					\
-} while (/* CONSTCOND */0)
+#define SDP_PUT128(l, cp) { \
+	register uint8_t *t_cp = (uint8_t *)(cp); \
+	*t_cp++ = (l)->b[15]; \
+	*t_cp++ = (l)->b[14]; \
+	*t_cp++ = (l)->b[13]; \
+	*t_cp++ = (l)->b[12]; \
+	*t_cp++ = (l)->b[11]; \
+	*t_cp++ = (l)->b[10]; \
+	*t_cp++ = (l)->b[9];  \
+	*t_cp++ = (l)->b[8];  \
+	*t_cp++ = (l)->b[7];  \
+	*t_cp++ = (l)->b[6];  \
+	*t_cp++ = (l)->b[5];  \
+	*t_cp++ = (l)->b[4];  \
+	*t_cp++ = (l)->b[3];  \
+	*t_cp++ = (l)->b[2];  \
+	*t_cp++ = (l)->b[1];  \
+	*t_cp   = (l)->b[0];  \
+	(cp) += 16; \
+}
+
+#define SDP_PUT_UUID128(l, cp) { \
+	register uint8_t *t_cp = (uint8_t *)(cp); \
+	*t_cp++ = (l)->b[0];  \
+	*t_cp++ = (l)->b[1];  \
+	*t_cp++ = (l)->b[2];  \
+	*t_cp++ = (l)->b[3];  \
+	*t_cp++ = (l)->b[4];  \
+	*t_cp++ = (l)->b[5];  \
+	*t_cp++ = (l)->b[6];  \
+	*t_cp++ = (l)->b[7];  \
+	*t_cp++ = (l)->b[8];  \
+	*t_cp++ = (l)->b[9];  \
+	*t_cp++ = (l)->b[10]; \
+	*t_cp++ = (l)->b[11]; \
+	*t_cp++ = (l)->b[12]; \
+	*t_cp++ = (l)->b[13]; \
+	*t_cp++ = (l)->b[14]; \
+	*t_cp   = (l)->b[15]; \
+	(cp) += 16; \
+}
 #elif BYTE_ORDER == BIG_ENDIAN
-#define SDP_PUT128(l, cp)	do {			\
-	memcpy((cp), &((l)->b), 16);			\
-	(cp) += 16;					\
-} while (/* CONSTCOND */0)
+#define SDP_PUT128(l, cp) { \
+	register uint8_t *t_cp = (uint8_t *)(cp); \
+	*t_cp++ = (l)->b[0];  \
+	*t_cp++ = (l)->b[1];  \
+	*t_cp++ = (l)->b[2];  \
+	*t_cp++ = (l)->b[3];  \
+	*t_cp++ = (l)->b[4];  \
+	*t_cp++ = (l)->b[5];  \
+	*t_cp++ = (l)->b[6];  \
+	*t_cp++ = (l)->b[7];  \
+	*t_cp++ = (l)->b[8];  \
+	*t_cp++ = (l)->b[9];  \
+	*t_cp++ = (l)->b[10]; \
+	*t_cp++ = (l)->b[11]; \
+	*t_cp++ = (l)->b[12]; \
+	*t_cp++ = (l)->b[13]; \
+	*t_cp++ = (l)->b[14]; \
+	*t_cp   = (l)->b[15]; \
+	(cp) += 16; \
+}
 
 #define SDP_PUT_UUID128(l, cp)	SDP_PUT128(l, cp)
 #else
@@ -464,9 +536,9 @@ int32_t            sdp_search     (void *xs,
                                    uint32_t alen, uint32_t const *ap,
                                    uint32_t vlen, sdp_attr_t *vp);
 
-char const *       sdp_attr2desc  (uint16_t attr);
-char const *       sdp_uuid2desc  (uint16_t uuid);
-void               sdp_print      (uint32_t level, uint8_t *start,
+char const *	   sdp_attr2desc  (uint16_t attr);
+char const *	   sdp_uuid2desc  (uint16_t uuid);
+void               sdp_print      (uint32_t level, uint8_t const *start,
                                    uint8_t const *end);
 
 /******************************************************************************
@@ -484,8 +556,8 @@ void               sdp_print      (uint32_t level, uint8_t *start,
  * and depend on the request.
  *
  * SDP_PDU_SERVICE_REGISTER_REQUEST
- *	pdu_header_t	hdr;
- *	uint16_t	uuid;	service class UUID (network byte order)
+ * 	pdu_header_t	hdr;
+ *	u_int16_t	uuid;	service class UUID (network byte order)
  *	bdaddr_t	bdaddr;	local BD_ADDR (or ANY)
  *	profile data[pdu->len - sizeof(uuid) - sizeof(bdaddr)]
  *
@@ -494,14 +566,14 @@ void               sdp_print      (uint32_t level, uint8_t *start,
  *
  * SDP_PDU_SERVICE_UNREGISTER_REQUEST
  *	pdu_header_t	hdr;
- *	uint32_t	record_handle;	(network byte order)
- *
+ *	u_int32_t	record_handle;	(network byte order)
+ * 
  * no additional data in response.
  *
  *
  * SDP_PDU_SERVICE_CHANGE_REQUEST
- *	pdu_header_t	hdr;
- *	uint32_t	record_handle;	(network byte order)
+ * 	pdu_header_t	hdr;
+ *	u_int32_t	record_handle;	(network byte order)
  *	profile data[pdu->len - sizeof(record_handle)]
  *
  * no additional data in response.
@@ -528,22 +600,6 @@ struct sdp_ftrn_profile
 typedef struct sdp_ftrn_profile		sdp_ftrn_profile_t;
 typedef struct sdp_ftrn_profile *	sdp_ftrn_profile_p;
 
-struct sdp_hset_profile
-{
-	uint8_t server_channel;
-	uint8_t	reserved[3];
-};
-typedef struct sdp_hset_profile		sdp_hset_profile_t;
-typedef struct sdp_hset_profile *	sdp_hset_profile_p;
-
-struct sdp_hf_profile
-{
-	uint8_t server_channel;
-	uint16_t supported_features;
-};
-typedef struct sdp_hf_profile		sdp_hf_profile_t;
-typedef struct sdp_hf_profile *		sdp_hf_profile_p;
-
 /* Keep this in sync with sdp_opush_profile */
 struct sdp_irmc_profile
 {
@@ -591,13 +647,48 @@ struct sdp_sp_profile
 typedef struct sdp_sp_profile	sdp_sp_profile_t;
 typedef struct sdp_sp_profile *	sdp_sp_profile_p;
 
+struct sdp_nap_profile
+{
+	uint8_t		reserved;
+	uint8_t		load_factor;
+	uint16_t	psm;			/* HBO */
+	uint16_t	security_description;	/* HBO */
+	uint16_t	net_access_type;	/* HBO */
+	uint32_t	max_net_access_rate;	/* HBO */
+};
+typedef struct sdp_nap_profile		sdp_nap_profile_t;
+typedef struct sdp_nap_profile *	sdp_nap_profile_p;
+
+struct sdp_gn_profile
+{	
+	uint8_t		reserved;
+	uint8_t		load_factor;
+	uint16_t	psm;			/* HBO */
+	uint16_t	security_description;	/* HBO */
+	uint16_t	reserved2;
+};
+typedef struct sdp_gn_profile		sdp_gn_profile_t;
+typedef struct sdp_gn_profile *		sdp_gn_profile_p;
+
+struct sdp_panu_profile
+{
+	uint8_t		reserved;
+	uint8_t		load_factor;
+	uint16_t	psm;			/* HBO */
+	uint16_t	security_description;	/* HBO */
+	uint16_t	reserved2;
+};
+typedef struct sdp_panu_profile		sdp_panu_profile_t;
+typedef struct sdp_panu_profile *	sdp_panu_profile_p;
+
 int32_t	sdp_register_service	(void *xss, uint16_t uuid,
-				 bdaddr_t *bdaddr, uint8_t *data,
+				 bdaddr_p const bdaddr, uint8_t const *data,
 				 uint32_t datalen, uint32_t *handle);
 int32_t	sdp_unregister_service	(void *xss, uint32_t handle);
 int32_t	sdp_change_service	(void *xss, uint32_t handle,
-				 uint8_t *data, uint32_t datalen);
+				 uint8_t const *data, uint32_t datalen);
 
 __END_DECLS
 
 #endif /* ndef _SDP_H_ */
+
diff --git a/lib/libsdp/search.c b/lib/libsdp/search.c
index b586f2fc64..803eb8f0e6 100644
--- a/lib/libsdp/search.c
+++ b/lib/libsdp/search.c
@@ -1,6 +1,3 @@
-/* $NetBSD: search.c,v 1.1 2006/06/19 15:44:36 gdamore Exp $ */
-/* $DragonFly: src/lib/libsdp/search.c,v 1.1 2008/01/03 11:47:53 hasso Exp $ */
-
 /*
  * search.c
  *
@@ -13,10 +10,10 @@
  * 1. Redistributions of source code must retain the above copyright
  *    notice, this list of conditions and the following disclaimer.
  * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
+ *    notice, this list of conditions and the following disclaimer in the 
  *    documentation and/or other materials provided with the distribution.
  *
- * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND 
  * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
@@ -28,8 +25,8 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- * $Id: search.c,v 1.1 2006/06/19 15:44:36 gdamore Exp $
- * $FreeBSD: src/lib/libsdp/search.c,v 1.7 2004/12/09 18:57:12 emax Exp $
+ * $Id: search.c,v 1.2 2003/09/04 22:12:13 max Exp $
+ * $FreeBSD: head/lib/libsdp/search.c 173673 2007-11-16 15:13:12Z emax $
  */
 
 #include <sys/uio.h>
@@ -104,7 +101,7 @@ sdp_search(void *xss,
 		ss->error = ENOBUFS;
 		return (-1);
 	}
-
+		
 	/* Put ServiceSearchPattern */
 	SDP_PUT8(SDP_DATA_SEQ16, req);
 	SDP_PUT16(plen, req);
@@ -207,15 +204,18 @@ sdp_search(void *xss,
 			return (-1);
 		}
 
+		rsp += xpdu.len;
+		ss->tid ++;
+
 		/* Save continuation state (if any) */
-		ss->cslen = rsp[xpdu.len];
+		ss->cslen = rsp[0];
 		if (ss->cslen > 0) {
 			if (ss->cslen > sizeof(ss->cs)) {
 				ss->error = ENOBUFS;
 				return (-1);
 			}
 
-			memcpy(ss->cs, rsp + xpdu.len + 1, ss->cslen);
+			memcpy(ss->cs, rsp + 1, ss->cslen);
 
 			/*
 			 * Ensure that we always have ss->imtu bytes
@@ -227,7 +227,7 @@ sdp_search(void *xss,
 
 				size = ss->rsp_e - ss->rsp + ss->imtu;
 				offset = rsp - ss->rsp;
-
+		
 				rsp_tmp = realloc(ss->rsp, size);
 				if (rsp_tmp == NULL) {
 					ss->error = ENOMEM;
@@ -239,9 +239,6 @@ sdp_search(void *xss,
 				rsp = ss->rsp + offset;
 			}
 		}
-
-		rsp += xpdu.len;
-		ss->tid ++;
 	} while (ss->cslen > 0);
 
 	/*
@@ -249,12 +246,12 @@ sdp_search(void *xss,
 	 * we must populate attribute values into vp array. At this point
 	 * ss->rsp points to the beginning of the response and rsp points
 	 * to the end of the response.
-	 *
+	 * 
 	 * From Bluetooth v1.1 spec page 364
-	 *
+	 * 
 	 * The AttributeLists is a data element sequence where each element
 	 * in turn is a data element sequence representing an attribute list.
-	 * Each attribute list contains attribute IDs and attribute values
+	 * Each attribute list contains attribute IDs and attribute values 
 	 * from one service record. The first element in each attribute list
 	 * contains the attribute ID of the first attribute to be returned for
 	 * that service record. The second element in each attribute list
@@ -263,9 +260,9 @@ sdp_search(void *xss,
 	 * and value pairs. Only attributes that have non-null values within
 	 * the service record and whose attribute IDs were specified in the
 	 * SDP_ServiceSearchAttributeRequest are contained in the AttributeLists
-	 * Neither an attribute ID nor attribute value is placed in
-	 * AttributeLists for attributes in the service record that have no
-	 * value. Within each attribute list, the attributes are listed in
+	 * Neither an attribute ID nor attribute value is placed in 
+	 * AttributeLists for attributes in the service record that have no 
+	 * value. Within each attribute list, the attributes are listed in 
 	 * ascending order of attribute ID value.
 	 */
 
@@ -421,3 +418,4 @@ sdp_search(void *xss,
 
 	return (0);
 }
+
diff --git a/lib/libsdp/service.c b/lib/libsdp/service.c
index 9def829748..0d9bcf8bf0 100644
--- a/lib/libsdp/service.c
+++ b/lib/libsdp/service.c
@@ -1,36 +1,3 @@
-/* $NetBSD: service.c,v 1.1 2006/06/19 15:44:36 gdamore Exp $ */
-/* $DragonFly: src/lib/libsdp/service.c,v 1.1 2008/01/03 11:47:53 hasso Exp $ */
-
-/*-
- * Copyright (c) 2006 Itronix Inc.
- * All rights reserved.
- *
- * Written by Iain Hibbert for Itronix Inc.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
- *    documentation and/or other materials provided with the distribution.
- * 3. The name of Itronix Inc. may not be used to endorse
- *    or promote products derived from this software without specific
- *    prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY ITRONIX INC. ``AS IS'' AND
- * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
- * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
- * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL ITRONIX INC. BE LIABLE FOR ANY
- * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
- * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
- * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
- * ON ANY THEORY OF LIABILITY, WHETHER IN
- * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
- * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
- * POSSIBILITY OF SUCH DAMAGE.
- */
 /*
  * service.c
  *
@@ -43,10 +10,10 @@
  * 1. Redistributions of source code must retain the above copyright
  *    notice, this list of conditions and the following disclaimer.
  * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
+ *    notice, this list of conditions and the following disclaimer in the 
  *    documentation and/or other materials provided with the distribution.
  *
- * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND 
  * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
@@ -58,8 +25,8 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- * $Id: service.c,v 1.1 2006/06/19 15:44:36 gdamore Exp $
- * $FreeBSD: src/lib/libsdp/service.c,v 1.1 2004/01/20 20:48:25 emax Exp $
+ * $Id: service.c,v 1.1 2004/01/13 19:32:36 max Exp $
+ * $FreeBSD: head/lib/libsdp/service.c 124758 2004-01-20 20:48:26Z emax $
  */
 
 #include <sys/uio.h>
@@ -76,8 +43,8 @@
 static int32_t sdp_receive_error_pdu(sdp_session_p ss);
 
 int32_t
-sdp_register_service(void *xss, uint16_t uuid, bdaddr_t *bdaddr,
-		uint8_t *data, uint32_t datalen, uint32_t *handle)
+sdp_register_service(void *xss, uint16_t uuid, bdaddr_p const bdaddr,
+		uint8_t const *data, uint32_t datalen, uint32_t *handle)
 {
 	sdp_session_p	ss = (sdp_session_p) xss;
 	struct iovec	iov[4];
@@ -155,12 +122,10 @@ sdp_unregister_service(void *xss, uint32_t handle)
 		ss->error = EINVAL;
 		return (-1);
 	}
-#if 0
 	if (sizeof(pdu) + sizeof(handle) > SDP_LOCAL_MTU) {
 		ss->error = EMSGSIZE;
 		return (-1);
 	}
-#endif
 
 	pdu.pid = SDP_PDU_SERVICE_UNREGISTER_REQUEST;
 	pdu.tid = htons(++ss->tid);
@@ -188,7 +153,7 @@ sdp_unregister_service(void *xss, uint32_t handle)
 
 int32_t
 sdp_change_service(void *xss, uint32_t handle,
-		uint8_t *data, uint32_t datalen)
+		uint8_t const *data, uint32_t datalen)
 {
 	sdp_session_p	ss = (sdp_session_p) xss;
 	struct iovec	iov[3];
@@ -236,12 +201,12 @@ sdp_change_service(void *xss, uint32_t handle,
 static int32_t
 sdp_receive_error_pdu(sdp_session_p ss)
 {
-	sdp_pdu_t	pdu;
+	sdp_pdu_p	pdu;
 	int32_t		len;
 	uint16_t	error;
 
 	do {
-		len = read(ss->s, ss->rsp, (size_t)(ss->rsp_e - ss->rsp));
+		len = read(ss->s, ss->rsp, ss->rsp_e - ss->rsp);
 	} while (len < 0 && errno == EINTR);
 
 	if (len < 0) {
@@ -249,13 +214,12 @@ sdp_receive_error_pdu(sdp_session_p ss)
 		return (-1);
 	}
 
-	memcpy(&pdu, ss->rsp, sizeof(pdu));
-	pdu.tid = ntohs(pdu.tid);
-	pdu.len = ntohs(pdu.len);
-	memcpy(ss->rsp, &pdu, sizeof(pdu));
+	pdu = (sdp_pdu_p) ss->rsp;
+	pdu->tid = ntohs(pdu->tid);
+	pdu->len = ntohs(pdu->len);
 
-	if (pdu.pid != SDP_PDU_ERROR_RESPONSE || pdu.tid != ss->tid ||
-	    pdu.len < 2 || pdu.len != len - sizeof(pdu)) {
+	if (pdu->pid != SDP_PDU_ERROR_RESPONSE || pdu->tid != ss->tid ||
+	    pdu->len < 2 || pdu->len != len - sizeof(*pdu)) {
 		ss->error = EIO;
 		return (-1);
 	}
@@ -270,3 +234,4 @@ sdp_receive_error_pdu(sdp_session_p ss)
 
 	return (len);
 }
+
